#include <stdio.h>

extern "C" {
    void VMProtectBeginVirtualization( const char* );
    void VMProtectEnd();
}

class Exception
{
  public:
    Exception()
    {
        printf("Exception::Exception()\n");
    }

    ~Exception()
    {
        printf("Exception::~Exception()\n");
    }
};

#pragma clang optimize off
int main()
{
    // With first try-catch block endless exceptions creation
    // try
    // {
    //     printf("try - start\n" );
    //     throw new Exception();
    // }
    // catch( Exception* ex )
    // {
    //     printf("catch( Exception* ex )\n" );
    //     delete ex;
    // }
    //
    // printf("after try\n" );

    int x = 0;
    VMProtectBeginVirtualization( "" );
    ++x;
    VMProtectEnd();

    try
    {
        printf("try - start\n" );
        throw new Exception();
    }
    catch( Exception* ex )
    {
        printf("catch( Exception* ex )\n" );
        delete ex;
    }

    printf("after try\n" );

    //while( 1 )
    //{
    //}

    return 0;
}
#pragma clang optimize on
